import os, sys, linecache
root = os.getcwd()

# set directories
benchmarkdir=root+'\\Benchmark\\'
randomdir=root+'\\randomcut\\randomcut\\'
dirpara=root+'\\all\\all\\txtused\\'
modelpath=root+'\\all\\all\\off\\'
pathout=root+'\\all\\all\\output\\user\\'
segpath=root+'\\all\\all\\seg\\Randcuts\\'
tool=root+'\\aei'


def isranexist(segment,meshindex):
    a=os.listdir(randomdir+meshindex+'\\')
    if segment in a:
        return True
    else :
        return False
    
def calmax( filename ):
    file=open(filename)
    lines=file.readlines()
    lines = [ int(x) for x in lines ]
    Max=max(lines)
    return  Max+1

def normalize( filename1,filename2,filename3):
    file=open(filename2)
    lines=file.readlines()
    lines = [ float(x) for x in lines ]
    mean=sum(lines)/len(lines)
    
    file1=open(filename1)
    result=float(str(file1.readline()))
    finalresult=result/mean
    if finalresult>1:
        finalresult=1
    finalresult="{:.4f}".format(finalresult)
    file2=open(filename3,'w')
    file2.write(finalresult)

offname=os.listdir(segpath)
offname.sort(key=lambda x:int(x[:]))

for i in offname:
    segname=os.listdir(segpath+i)
    segname.sort(key=lambda x:int(x[x.rindex("_")+1:-4]))
    for j in segname:
        segment=j[j.rindex("_")+1:-4]
        #print(segment)
        if not isranexist(segment,i):
            print('Can not find the random segmentation file!')
            continue
        segfullname=segpath+'%s\\'%i + '%s' %j
        #print(segfullname)
        #segment=readfile(segfullname)
        #print(segment)
        Pathout=pathout+'unnormalized\\'+str(i)+'\\'
        norPathout=pathout+'normalized\\'+str(i)+'\\'
        ePathout=pathout+'..\\expectation\\'+str(i)+'\\'
        
        isExists=os.path.exists(Pathout)
        if not isExists:
            os.makedirs(Pathout)
        isExists=os.path.exists(norPathout)
        if not isExists:
            os.makedirs(norPathout)
        isExists=os.path.exists(ePathout)
        if not isExists:
            os.makedirs(ePathout)
        out=Pathout+j[:-4]+'.txt'
        cmd = '%s %s %s %s %s %s %s' %(tool,modelpath,out,i,segfullname,dirpara+'segcount.txt',benchmarkdir)
        isExists=os.path.exists(out)
        if not isExists:
            os.system(cmd)
        
        ranout=ePathout+'ran'+j[:-4]+'.txt'
        isExists=os.path.exists(ranout)
        if not isExists:
            ranseglist=[]
            ranseglist.append('')
            ranseglist=ranseglist+list(range(1,11))
            for k in ranseglist:
                ransegfullname=randomdir+ '%s\\' %i + str(segment) + '\\aran' + str(k) + '.seg'
                isExists=os.path.exists(ransegfullname)
                #print(ransegfullname)
                #print(ranout)
                if isExists:
                    cmd = '%s %s %s %s %s %s %s' %(tool,modelpath,ranout,i,ransegfullname,dirpara+'segcount.txt',benchmarkdir)
                    os.system(cmd)
        finalout=norPathout+'final'+j[:-4]+'.txt'
        isExists=os.path.exists(finalout)
        if not isExists:
            normalize(out,ranout,finalout)


    
